package shanghu

import (
	"duoduo/apis/shanghu/models"
	"duoduo/models/shanghu"
	"duoduo/tools/app"
	"errors"
	"github.com/gin-gonic/gin"
)

// 充值
func MerchantRecharge(c *gin.Context) {
	var inData models.MerchantRechargeRequest
	var merchantRecharge shanghu.MerchantRecharge
	var merchantClientTicket shanghu.MerchantClientTicket
	var clientOpenId shanghu.MerchantClientUser
	err := c.ShouldBindJSON(&inData)
	if err != nil {
		app.Error(c, 400, err, err.Error())
		return
	}

	// 查客户id
	clientOpenId.Code = inData.ClientCode
	clientInfo, err := clientOpenId.GetUserInfoByCode()
	if err != nil {
		if err.Error() == "record not found" {
			app.Error(c, 400, errors.New("请确认用户ID是否正确"), "请确认用户ID是否正确")
			return
		}

		app.Error(c, 400, err, err.Error())
		return
	}

	merchantRecharge.ID = inData.MerchantRechargeID

	merchantRechargeInfo, err := merchantRecharge.GetMerchantRecharge()
	if err != nil {
		app.Error(c, 400, err, err.Error())
		return
	}

	//json
	err = merchantClientTicket.Recharge(merchantRechargeInfo, clientInfo.ClientOpenID, inData.MerchantOpenID)
	if err != nil {
		app.Error(c, 400, err, err.Error())
		return
	}

	app.OK(c, nil, app.Success)

}
